#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>           
#include <unistd.h>        
#include <sys/wait.h>                      
#include <sys/ioctl.h>
#include "../mergemod/mergemod.h"


void err_exit( const char *msg )
{
  printf(msg);
  exit(1);
}

/* ALPHA save, will also work on Intel */
#define PSIZE 8192

char tbuffer[PSIZE*2];

#define MAGIC_NUMBER 4711

main()
{
  int mergemod_fd;
  int cpid;
  int *testfield;
  int pbuffer[2048];
  struct mergemem_get_page mgp;

  if( (mergemod_fd = open("/dev/mergemem", O_RDONLY)) == -1 )
    err_exit("can not open /dev/mergemem\n");

  /* the testfield must be page-alligned */
  testfield = (int *)((unsigned long)(tbuffer+PSIZE) & ~(PSIZE-1));

  switch( cpid = fork() )
    {
    case -1: 
      err_exit("can not fork\n"); 
      break;

    case 0: /*child*/
      testfield[0]=MAGIC_NUMBER;
      sleep(2); /* hang around for some time.. */
      break;

    default: /* parent */      
      mgp.pid = cpid;
      mgp.addr = (unsigned long)testfield;
      mgp.page = (char*)pbuffer;
      
      sleep(1); /* Child might write something to the testfield */
      
      if(ioctl(mergemod_fd, MERGEMEM_GET_PAGE, &mgp) != MERGEMEM_SUCCESS)
	err_exit("ioctl() failed\n");
      
      if(pbuffer[0]==MAGIC_NUMBER) printf("hey ho! it works\n");

      printf("Waiting for child...\n");
      if(cpid != wait(NULL)) err_exit("that was not my child\n");
    }
}
